# -*- coding: utf-8 -*-
#
# Copyright (c) 2022 CSIRO Space and Astronomy.
# All rights reserved

"""Correlator Model"""

import argparse
import os.path
import typing

import matplotlib.pyplot as plt
import numpy as np
from scapy.all import IP, UDP, Ether, sendp, wrpcap

from ska_low_cbf_model import decode, filterbank, lfaa_spead, raw
from ska_low_cbf_model.spead import (
    SpeadDescriptor,
    SpeadEnd,
    SpeadInitialisation,
    SpeadSDP,
)

# location of maximum sample in the FIR filter for the correlator filterbank
FILTER_CENTER = 23598


def command_line_args():
    # Some example values for the command line arguments :
    # test case : -t ../../src_atomic/run_cor_2sa_21stations
    # filterbank taps : -f ../../src_atomic/correlator-filter.txt
    # From pycharm you can set these via run->edit configurations
    parser = argparse.ArgumentParser(description="CryoPAF Beamformer Model")

    parser.add_argument(
        "-t", "--test-case", help="Path to the test case to run", required=True
    )
    parser.add_argument(
        "-f",
        "--filterbank-taps",
        help="text file with filterbank taps",
        required=True,
    )
    parser.add_argument(
        "-c",
        "--ccfg",
        help="ARGs ccfg file to convert register names into addresses",
    )

    parser.add_argument(
        "--show-plots",
        help="Show plots for debugging",
        dest="plot",
        action="store_true",
    )
    parser.add_argument(
        "-w",
        "--write-to-file",
        help="file to write model as a pcap file",
    )
    parser.add_argument(
        "--send-packet",
        help="Send Packet to a given interface",
        dest="packet",
        action="store_true",
    )
    parser.add_argument(
        "-i",
        "--interface-to-send",
        default="wlo1",
        help="network interface to send the packet",
    )

    return parser.parse_args()


def load_raw(headers: typing.BinaryIO, data: typing.BinaryIO):
    """
    Loads a set of RAW samples files for signal samples to process through the
    model

    :param headers: header file
    :param data: samples file
    """
    print(
        f"🍣 Loading raw packet headers: {headers.name}, samples: {data.name}"
    )
    return raw.RawDataParser(
        np.frombuffer(headers.read(), dtype=raw.raw_header),
        np.frombuffer(data.read(), dtype=np.uint8),
    )


def parse_registers(register_file):
    """
    Loads register settings from a text file. The register file should be

    [register name][offset]   <-- Name and address offset from the start of
    this register. Note offset is in bytes.
    data                      <-- as hex e.g. 0x12345678. Each line is 4 bytes.

    Returns a dictionary indexed by the register name,
    where each entry is a numpy array with the register contents.
    The size of the numpy array is set by the maximum offset specified in the
    file. Unspecified values in a register are set to 0.
    """
    reg_name = ""
    reg_value = {}
    """key: register name, values: a list of values for each name"""
    reg_addr = {}
    """key: register name, values: a list of addresses matching the values"""
    reg_offset = 0

    for line in register_file:
        if "]" in line:
            # This line contains a register name and offset,
            # i.e. [reg_name][offset]
            reg_name_offset = line.split("]")
            # We expect reg_name to be wrapped in [],
            # so need to drop the first character
            reg_name = reg_name_offset[0][1:]
            # The offset in the file is in bytes, /4 to get the word address
            reg_offset = int(int(reg_name_offset[1][1:]) / 4)
            if not (reg_name in reg_value):
                # put empty lists in for the values for this register
                reg_value[reg_name] = []
                reg_addr[reg_name] = []
        else:
            # We must already have a current register name,
            # now we are getting the data
            reg_value[reg_name].append(int(line, 16))
            reg_addr[reg_name].append(reg_offset)
            reg_offset += 1
    # Go through all the registers and convert the contents to a numpy array.
    registers = {}  # start out with an empty dictionary
    for k in reg_value:
        max_addr = max(reg_addr[k])
        registers[k] = np.zeros(max_addr + 1, dtype=np.uint32)
        for offset_index in range(len(reg_addr[k])):
            registers[k][reg_addr[k][offset_index]] = reg_value[k][
                offset_index
            ]
    return registers


def write_tb_regfile(reg_with_names, ccfg, tb_filename) -> int:
    """
    Takes the register file which uses the register names,
    and uses the mapping in the ccfg file to convert to register addresses.
    Writes out the result in the file tb_filename
    :param reg_with_names: register config file with register names
    :param ccfg: ccfg file generated by ARGs
    :param tb_filename: name of the output file.
    :return: Text file format suitable for use in the top level correlator testbench
    """
    # Parse the ccfg file
    name_addr_dict = {}
    # with open(ccfg_name,'r') as ccfg:
    for ccfg_line in ccfg:
        ccfg_split = ccfg_line.split()
        if (
            ccfg_split[0] == "BitField"
            or ccfg_split[0] == "BlockRAM"
            or ccfg_split[0] == "DistrRAM"
        ):
            address = ccfg_split[1]
            concatenated_name = ""
            for concat_element in ccfg_split[4:]:
                concatenated_name = concatenated_name + "." + concat_element
            name = concatenated_name[1:]
            name_addr_dict[name] = address

    # Replace register names with addresses and lengths.
    dataList = []
    burstActive = False
    outString = ""
    wrAddr = 0
    for inputLine in reg_with_names:
        inputLine3 = inputLine.replace("]", " ")
        inputLine4 = inputLine3.replace("[", " ")
        inputSplit = inputLine4.split()
        if inputLine[0] == "[":
            if burstActive:
                # write out the previous command now we know how many data words there are. Note length is the number of bytes, not words.
                outString = (
                    outString
                    + "wr "
                    + "{0:0>8x}".format(wrAddr)
                    + " "
                    + "{0:0>8x}".format(4 * len(dataList))
                    + "\n"
                )
                for dout in dataList:
                    outString = outString + dout + "\n"
                dataList = []
                burstActive = False
            if inputSplit[0] in name_addr_dict:
                wrAddr = name_addr_dict[inputSplit[0]]
                wrAddrOffset = inputSplit[1]
                # wrAddr, taken from the ccfg file, is in words,
                # but wrAddrOffset, from the registers.txt file, is in bytes.
                wrAddr = 4 * int(wrAddr, 16) + int(wrAddrOffset, 10)
                burstActive = True
            else:
                print(
                    "Register "
                    + inputSplit[0]
                    + " was not found in the ccfg file, ignoring it."
                )
                wrAddr = "0"
        else:
            dataList.append(inputSplit[0][2:])
    # Put in the last transaction
    if burstActive:
        outString += (
            "wr "
            + "{0:0>8x}".format(wrAddr)
            + " "
            + "{0:0>8x}".format(4 * len(dataList))
            + "\n"
        )
        for dout in dataList:
            outString += dout + "\n"
        burstActive = False

    with open(tb_filename, "w") as reg_file:
        reg_file.write(outString)
    return 1


def run_filterbank(
    delay_table, samples, fir_taps, show_plots: bool = True
) -> (np.ndarray, np.ndarray):
    """
    Run the filterbank.
    For each virtual channel in the input samples:
    - Get the coarse and fine delays from the delay table,
    - pad the data with an appropriate number of zeros defined by the coarse
    delay
    - Apply the 4096 point filterbank
    - Apply the fine delay phase correction
    - scale and saturate to get back to 8+8 bit complex values.

    :param delay_table: 2 x 32 bit words for each virtual channel, as per the
    firmware configuration.
    word 0 - bits 10:0 = coarse delay
         bits 31:16 = H pol delta phase = phase step across the coarse channel
    word 1 - bits 15:0 = V pol delta phase = phase step across the coarse ch.
         bits 31:16 = delta delta phase, common to both polarisations.
    :param samples: numpy array with dimensions (virtual channels) *
    (2 polarisations) * (time samples)
    :param fir_taps: text file with the filterbank FIR taps.
    :param show_plots: do you want to display plots?

    :returns: two numpy arrays, (data,valid) :
    data  : (virtual channels) * (2 polarisations) * (3456 fine channels)
    * (N time samples)
    complex floating point values, but rounded to integers, and in the range
    -128 to 127.
    A value of -128 indicates that the value has been clipped.
    valid : (virtual channels) * (3456 fine channels) * (N time samples)
    Boolean array indicating that the corresponding element in the data array
    is i.e. not clipped or marked as RFI. Note individual real or imaginary
    components may be set to -128 to indicate RFI or clipping, but the valid
    array has a single value for both polarisation and real/imaginary.
    """
    virtual_channels = samples.shape[0]
    coarse_time_samples = samples.shape[2]

    fb = filterbank.PolyphaseFilterBank(fir_taps)
    output_time_samples = int(np.floor(coarse_time_samples / 4096))
    # require a multiple of 4 virtual channels in the output,
    # to match the firmware.
    # (firmware processes data through the filterbanks in groups of 4 virtual
    # channels)
    virtual_channels_roundup = int(np.ceil(virtual_channels / 4) * 4)
    full_fb_out = np.zeros(
        (virtual_channels_roundup, 2, 3456, output_time_samples),
        dtype=np.complex64,
    )
    full_fb_valid = np.full(
        (virtual_channels_roundup, 3456, output_time_samples), True
    )
    clip_count = np.zeros(virtual_channels)
    for vc in range(virtual_channels):
        print(f"running filterbank for virtual channel {vc}")
        for pol in range(2):
            coarse_delay = np.mod(delay_table[vc * 4], 65536)
            if pol == 0:  # Get the phase shift across the channel,
                # for the selected polarisation
                # "H" pol
                delta_p_coarse = np.double(
                    np.int16(np.floor(delay_table[vc * 4] / 65536))
                )
                p_offset = np.double(
                    np.int16(np.mod(delay_table[vc * 4 + 2], 65536))
                )
            else:
                # "V" pol
                delta_p_coarse = np.double(
                    np.int16(np.mod(delay_table[vc * 4 + 1], 65536))
                )
                p_offset = np.double(
                    np.int16(np.floor(delay_table[vc * 4 + 2] / 65536))
                )
            delta_delta_p_coarse = np.double(
                np.int16(np.floor(delay_table[vc * 4 + 1] / 65536))
            )
            p_offset_step = np.double(np.int32(delay_table[vc * 4 + 3]))
            fb_input = lfaa_spead.complex64_from_complex_int8(
                samples[vc, pol, :]
            )
            # This assumes that the first frame in the first buffer in corner
            # turn 1 is frame 0. This should be matched to the corner turn 1
            # register "scanstartpacketcount".
            #
            # From the firmware comments:
            # The coarse delay is up to 2047 LFAA samples.
            # The last sample output to the correlator filterbanks for a
            # frame is <last sample in frame> - 2048 + coarse_delay
            # This means that the first sample output to the correlator
            # filterbanks will be
            # <last sample in previous frame> - 2048 + coarse_delay - <preload>
            # = <last sample in previous frame> - 2048 + coarse_delay
            #   - 11 * 4096
            # =  <last sample in previous frame> - 47104 + coarse_delay
            # The model processes the entire time series at once, so we only
            # need to worry about initialisation at the start. So the added
            # zeros at the start is the number of samples from the previous
            # frame, i.e.
            #  = 47104 - coarse_delay
            # The output has shape (time samples) x (fine channels)
            fb_output = fb.filter(
                fb_input,
                time_steps=output_time_samples,
                derotate=False,
                preload_zeros=(47104 - coarse_delay),
                saturate=False,
                fft_scale=8192,
            )
            fb_fine_delay = fb_output.copy()
            # Fine delay
            fine_freq = np.linspace(-1728, 1727, 3456)
            for time_sample in range(output_time_samples):
                # 4096 SPS samples per output time sample.
                n_64sample_blocks = (
                    time_sample * 4096 - (47104 - FILTER_CENTER - coarse_delay)
                ) / 64
                delta_p_coarse_final = (
                    delta_p_coarse
                    + n_64sample_blocks * delta_delta_p_coarse * (2 ** (-15))
                )
                offset_final = (
                    p_offset * 65536 + n_64sample_blocks * p_offset_step
                )
                phase_correction = np.exp(
                    -1j
                    * (
                        (2 ** (-32)) * 2 * np.pi * offset_final
                        + (2 ** (-15))
                        * 2
                        * np.pi
                        * fine_freq
                        * delta_p_coarse_final
                        / 2048
                    )
                )
                fb_fine_delay[time_sample, :] = (
                    fb_fine_delay[time_sample, :] * phase_correction
                )

            # RFI detection : replace any values outside the range
            # -127 to 127 with -128.
            fb_real_int = np.round(fb_fine_delay.real)
            fb_imag_int = np.round(fb_fine_delay.imag)
            fb_real_clip = np.logical_or(
                (fb_real_int > 127), (fb_real_int < -127)
            )
            fb_imag_clip = np.logical_or(
                (fb_imag_int > 127), (fb_imag_int < -127)
            )
            fb_real_int[fb_real_clip] = -128
            fb_imag_int[fb_imag_clip] = -128

            full_fb_out[vc, pol, :, :] = fb_real_int.T + 1j * fb_imag_int.T
            fb_valid = np.logical_not(
                np.logical_or(fb_real_clip, fb_imag_clip)
            )
            if pol == 0:
                full_fb_valid[vc, :, :] = fb_valid.T
            else:
                full_fb_valid[vc, :, :] = np.logical_and(
                    full_fb_valid[vc, :, :], fb_valid.T
                )
                clip_count[vc] += np.sum(
                    np.logical_not(full_fb_valid[vc, :, :])
                )

    print(f"Number of samples clipped in each virtual channel : {clip_count}")

    if show_plots:
        plt.figure(1)
        plt.clf()
        plt.subplot(2, 1, 1)
        plt.plot(np.real(full_fb_out[0, 0, :, 20]), "r.-")
        plt.plot(np.imag(full_fb_out[0, 0, :, 20]), "g.-")
        plt.title("real and imag for all fine channels, vc = 0, t = 20")
        plt.subplot(2, 1, 2)
        plt.plot(np.abs(full_fb_out[0, 0, :, 20]), "r.-")
        plt.title("absolute value, vc = 0, t = 20")

    return full_fb_out, full_fb_valid


def subarray_beam_unpack(sb_table: np.ndarray, sb_index: int) -> dict:
    """
    Unpack the data from the subarray beam table

    :param sb_table: Array of uint32, contents of the subarray beam table.
        4 words per entry.
        sb_table matches the format used in the firmware.
    :param sb_index: The table entry to decode.
    :returns: a dictionary with the fields unpacked.
    """
    if (4 * sb_index) >= sb_table.shape[0]:
        # asked for something beyond the end of the table, so fill with zeros.
        SB_data = {
            "N_stations": 0,
            "coarse_start": 0,
            "fine_start": 0,
            "N_fine": 0,
            "N_fine_integrate": 0,
            "N_time_integrate": 0,
            "HBM_base": 0,
        }
    else:
        SB_data = {
            # Number of stations for this subarray-beam
            "N_stations": np.mod(sb_table[sb_index * 4], 65536),
            # starting coarse frequency channel for this subarray-beam
            "coarse_start": int(np.floor(sb_table[sb_index * 4] / 65536)),
            # starting fine frequency channel for this subarray-beam
            "fine_start": np.mod(sb_table[sb_index * 4 + 1], 65536),
            # total number of fine channels for this subarray-beam
            "N_fine": np.mod(sb_table[sb_index * 4 + 2], 2**24),
            # fine channels per integration
            "N_fine_integrate": int(
                np.mod(np.floor(sb_table[sb_index * 4 + 2] / (2**24)), 64)
            ),
            # integration time
            "N_time_integrate": np.floor(
                sb_table[sb_index * 4 + 2] / (2**30)
            ),
            # Base address in HBM to store this subarray-beam
            "HBM_base": sb_table[sb_index * 4 + 3],
        }
    # convert number of samples to integrate in time from an index
    # to the actual number of samples.
    if SB_data["N_time_integrate"] == 0:
        SB_data["N_time_integrate"] = 64
    elif SB_data["N_time_integrate"] == 1:
        SB_data["N_time_integrate"] = 192
    else:
        print(
            "Number of time samples to integrate in subarray beam table "
            f"(index = {sb_index}) is invalid"
        )
    return SB_data


def get_corr_hbm(
    fine_data,
    fine_valid,
    vc_demap_table,
    subarray_beam_table,
    do_file_write=False,
    fname="",
    fname_check="",
):
    """
    Uses vc_demap_table and subarray_beam_table to put the fine channel data
    (i.e. the output of the filterbank) into data structures for each
    subarray-beam, organised similarly to the data in the HBM in the second
    corner turn in the firmware.
    If do_file_write = True, then the data is also written as a text file that
    can be loaded as the initialisation data for the HBM in the second corner
    turn, for use in the simulation.

    :param fine_data: (virtual channels) x (2 pol) x (3456 fine channels) x
    (192 time samples)
    :param fine_valid: boolean array, dimensions
    (virtual channels) * (3456 fine channels) * (192 time samples)
    :param do_file_write: if True, then a text file is written with HBM
    initialisation data.
    :param fname: Output text file name
    :param fname_check: name of file produced by the firmware simulation
    to check the data against. If this file exists, plots are produced
    comparing the model and simulation data, for the portion of the data that
    exists in the check file. Only runs if "do_file_write" is true, since
    the firmware only dumps data for the first frame.

    :return: The return value is the data in the HBM, organised as a list,
    where each entry in the list is the data for a particular subarray-beam,
    i.e. for one entry in subarray_beam_table
         Each list entry is a 4D numpy array with dimensions
        [(subarray stations) x (2 pol) x (fine channel) x (192 time samples)]

    Data in the HBM in the second corner turn in the firmware has :
     - Blocks of 512 bytes = (4 stations) * (32 time samples) * (2 pol) *
     (1+1 byte complex samples)
     The 4 stations are always from 4 consecutive virtual channels
    """

    virtual_channels = fine_data.shape[0]
    if do_file_write:
        hbm_data_file = open(fname, "w")
        if os.path.isfile(fname_check):
            hbm_check_data_file = open(fname_check, "rt")
            do_check = True
            check_data_list = []
            for hexword in hbm_check_data_file:
                check_data_list.append(int(hexword, 16))

            check_data_int32 = np.array(check_data_list, dtype=np.uint32)
            check_data_words = check_data_int32.shape[0]
            check_data_int8 = np.frombuffer(
                check_data_int32.tobytes(), dtype=np.int8
            )
            # check data has dimensions N x (2 pol), where N is the number of
            # 4 byte words in the file.
            check_data = np.zeros((check_data_words, 2), dtype=np.complex64)
            # pol 0
            check_data[:, 0] = (
                check_data_int8[0::4] + 1j * check_data_int8[1::4]
            )
            # pol 1
            check_data[:, 1] = (
                check_data_int8[2::4] + 1j * check_data_int8[3::4]
            )
            check_fine_data = np.zeros(fine_data.shape, dtype=np.complex64)
            check_valid = np.zeros(fine_valid.shape, dtype=np.int32)
            # check_data from the simulation (or HBM download) should have data for :
            # 4 stations, 64 time samples, 3456 fine channels
            # data is written in 512 byte blocks, which are 4 stations x 32 time samples
            # data in the check file is just a dump of memory from address 0 on.

        else:
            do_check = False
    else:
        do_check = False

    # return data is a list of numpy arrays
    hbm_data = list()
    data_valid = list()
    # create arrays for each subarray-beam in the subarray_beam table
    for sb_index in range(256):
        sb_entry = subarray_beam_unpack(subarray_beam_table, sb_index)
        if sb_entry["N_stations"] > 0:
            # require a multiple of 4 virtual channels in the output,
            # to match the firmware. (firmware processes data through the
            # filterbanks in groups of 4 virtual channels)
            virtual_channels_roundup = int(
                np.ceil(sb_entry["N_stations"] / 4) * 4
            )
            hbm_data.append(
                np.zeros(
                    (virtual_channels_roundup, 2, sb_entry["N_fine"], 192),
                    dtype=np.complex128,
                )
            )
            data_valid.append(
                np.full(
                    (virtual_channels_roundup, sb_entry["N_fine"], 192), True
                )
            )
        else:
            hbm_data.append(0)
            data_valid.append(0)

    for vc_block in range(int(np.ceil(virtual_channels / 4))):
        # Look up this virtual channel in vc_demap_table.
        # 2 words in the table for each group of 4 virtual channels.
        # Low 8 bits = subarray beam table index
        subarray_beam_index = int(np.mod(vc_demap_table[vc_block * 2], 256))
        # bits 19:8 = station
        subarray_beam_station = int(
            np.mod(np.floor(vc_demap_table[vc_block * 2] / 256), 4096)
        )
        # bits 28:20 = frequency
        sky_frequency = int(
            np.mod(np.floor(vc_demap_table[vc_block * 2] / (2**20)), 512)
        )
        subarray_beam_valid = np.floor(
            vc_demap_table[vc_block * 2] / (2**31)
        )

        block_512 = np.zeros((4, 2, 32, 2), dtype=np.int8)
        if subarray_beam_valid == 1:
            sb_entry = subarray_beam_unpack(
                subarray_beam_table, subarray_beam_index
            )
            if subarray_beam_station >= sb_entry["N_stations"]:
                print(
                    f" !!! Station number is invalid for vc_block {vc_block}"
                )
            sb_base_fine_channel = int(
                sb_entry["coarse_start"] * 3456 + sb_entry["fine_start"]
            )

            for fine_channel in range(3456):
                for time_block in range(6):
                    # 6 blocks of 32 time samples = 192 time samples per frame.
                    # Check: is this in the frequency range that we want?
                    this_fine_channel = sky_frequency * 3456 + fine_channel
                    if this_fine_channel >= sb_base_fine_channel:
                        # select the data for this 512-byte block
                        # will be an array with dimensions
                        # (4 channels)x(2 pol)x(1 fine channel)x(32 times)
                        # No built-in data type for complex ints,
                        # interleave the real and imaginary parts.
                        block_512[0:4, 0:2, :, 0] = np.squeeze(
                            np.int8(
                                np.round(
                                    np.real(
                                        fine_data[
                                            (vc_block * 4) : (
                                                (vc_block + 1) * 4
                                            ),
                                            :,
                                            fine_channel,
                                            (time_block * 32) : (
                                                (time_block + 1) * 32
                                            ),
                                        ]
                                    )
                                )
                            )
                        )
                        block_512[0:4, 0:2, :, 1] = np.squeeze(
                            np.int8(
                                np.round(
                                    np.imag(
                                        fine_data[
                                            (vc_block * 4) : (
                                                (vc_block + 1) * 4
                                            ),
                                            :,
                                            fine_channel,
                                            (time_block * 32) : (
                                                (time_block + 1) * 32
                                            ),
                                        ]
                                    )
                                )
                            )
                        )
                        # Format of the 512 byte block:
                        # 16 bytes per time sample, with :
                        #  bits(31:0) = time 0, station 0,
                        #  bits(63:32) = time 0, station 1;
                        #  bits(95:64) = time 0, station 2;
                        #  bits(127:96) = time 0, station 3;
                        # So we need to order block_512 first by re/im then by
                        # pol, then by station, then by time.
                        # convert from
                        # (4 stations) x (2 pol) x (32 times) x (2 re/im) into
                        # (32 times) x (4 stations) x (2 pol) x (2 re/im)
                        block_512_reordered = np.transpose(
                            block_512, (2, 0, 1, 3)
                        )
                        block_128_words = np.frombuffer(
                            block_512_reordered.tobytes(), dtype=np.uint32
                        )

                        # Work out where in HBM this 512 byte block should go
                        N_stations_div4 = np.ceil(sb_entry["N_stations"] / 4)
                        hbm_addr = (
                            sb_entry["HBM_base"]
                            + ((subarray_beam_station / 4) * 512)
                            + (this_fine_channel - sb_base_fine_channel)
                            * N_stations_div4
                            * 512
                            + time_block
                            * sb_entry["N_fine"]
                            * N_stations_div4
                            * 512
                        )
                        hbm_addr_4byte = np.uint32(np.floor(hbm_addr / 4))

                        # Put the data into a file for loading into the HBM in the firmware simulation
                        # valid doesn't go into the HBM, it is just encoded in values of -128 in the data.
                        if do_file_write:
                            hbm_data_file.write(f"{hbm_addr_4byte:08x}")
                            for w in range(128):
                                hbm_data_file.write(
                                    f" {block_128_words[w]:08x}"
                                )
                            hbm_data_file.write("\n")

                            # Reverse direction : extract data from the (simulation)/(hw HBM dump) file for this address
                            if do_check:
                                if check_data_words > hbm_addr_4byte:
                                    # check data has dimensions N x (2 pol), where N is the number of
                                    # 4 byte words in the file.
                                    hbm_dump_block_128_words = check_data[
                                        hbm_addr_4byte : (
                                            hbm_addr_4byte + 128
                                        ),
                                        :,
                                    ]
                                    hbm_dump_station0 = (
                                        hbm_dump_block_128_words[0::4, :]
                                    )
                                    hbm_dump_station1 = (
                                        hbm_dump_block_128_words[1::4, :]
                                    )
                                    hbm_dump_station2 = (
                                        hbm_dump_block_128_words[2::4, :]
                                    )
                                    hbm_dump_station3 = (
                                        hbm_dump_block_128_words[3::4, :]
                                    )
                                    # Format as per fine_data: (virtual channels)x(2 pol)x(3456 fine channels) x (192 time samples)
                                    for dump_pol in range(2):
                                        check_fine_data[
                                            vc_block * 4,
                                            dump_pol,
                                            fine_channel,
                                            (time_block * 32) : (
                                                (time_block + 1) * 32
                                            ),
                                        ] = hbm_dump_station0[:, dump_pol]
                                        check_fine_data[
                                            vc_block * 4 + 1,
                                            dump_pol,
                                            fine_channel,
                                            (time_block * 32) : (
                                                (time_block + 1) * 32
                                            ),
                                        ] = hbm_dump_station1[:, dump_pol]
                                        check_fine_data[
                                            vc_block * 4 + 2,
                                            dump_pol,
                                            fine_channel,
                                            (time_block * 32) : (
                                                (time_block + 1) * 32
                                            ),
                                        ] = hbm_dump_station2[:, dump_pol]
                                        check_fine_data[
                                            vc_block * 4 + 3,
                                            dump_pol,
                                            fine_channel,
                                            (time_block * 32) : (
                                                (time_block + 1) * 32
                                            ),
                                        ] = hbm_dump_station3[:, dump_pol]
                                    check_valid[
                                        vc_block * 4,
                                        fine_channel,
                                        (time_block * 32) : (
                                            (time_block + 1) * 32
                                        ),
                                    ] = True

                        # Put the data into the array for internal use,
                        # which is sorted by subarray-beam
                        hbm_data[subarray_beam_index][
                            subarray_beam_station : (
                                subarray_beam_station + 4
                            ),
                            :,
                            (this_fine_channel - sb_base_fine_channel),
                            (time_block * 32) : ((time_block + 1) * 32),
                        ] = fine_data[
                            (vc_block * 4) : ((vc_block + 1) * 4),
                            :,
                            fine_channel,
                            (time_block * 32) : ((time_block + 1) * 32),
                        ]
                        data_valid[subarray_beam_index][
                            subarray_beam_station : (
                                subarray_beam_station + 4
                            ),
                            (this_fine_channel - sb_base_fine_channel),
                            (time_block * 32) : ((time_block + 1) * 32),
                        ] = fine_valid[
                            (vc_block * 4) : ((vc_block + 1) * 4),
                            fine_channel,
                            (time_block * 32) : ((time_block + 1) * 32),
                        ]

    if do_check:
        # plot comparison of firmware and model:
        fine_plot = 1
        for station in range(6):
            plt.figure(station)
            plt.plot(fine_data[station, 0, fine_plot, 0:192].real, "r.-")
            plt.plot(check_fine_data[station, 0, fine_plot, 0:192].real, "go")
            plt.plot(fine_data[station, 0, fine_plot, 0:192].imag, "b.-")
            plt.plot(check_fine_data[station, 0, fine_plot, 0:192].imag, "co")
        plt.figure(7)
        plt.plot(fine_data[0, 0, :, 24].real, "r-")
        plt.plot(check_fine_data[0, 0, :, 24].real, "go")
        plt.plot(fine_data[0, 0, :, 24].imag, "b-")
        plt.plot(check_fine_data[0, 0, :, 24].imag, "co")
        plt.title("pol 0, station 0, time 24")
        plt.figure(8)
        plt.plot(fine_data[0, 1, :, 24].real, "r-")
        plt.plot(check_fine_data[0, 1, :, 24].real, "go")
        plt.plot(fine_data[0, 1, :, 24].imag, "b-")
        plt.plot(check_fine_data[0, 1, :, 24].imag, "co")
        plt.title("pol 1, station 0, time 24")
        plt.show()
    return hbm_data, data_valid


# Turn off black formatter.
# Really, I have no idea what people see in it.
# At best it makes trivial changes to formatting that provide no benefit,
# at worst - as in this function - it completely mangles the formatting,
# rendering the code unreadable by pointlessly putting every argument or
# array index on a new line.
# Sadly it is almost impossible to check code in to ska gitlab without allowing black to run.
# to disable black : use f m t: off (without the spaces)
def run_correlation(
    hbm_data,
    data_valid,
    subarray_beam_table,
    gen_lta_output=False,
    lta_fname="",
    tci_fd_fname="",
    lta_HBM_fname="",
    lta_HBM_dbg_fname="",
):
    """
    Do the correlation for the data in the HBM, for each subarray-beam listed
    in the subarray-beam table for a single 849ms block of data.

    :param hbm_data: List of numpy arrays, with each containing the required
    data for one entry in the subarray beam table.
    Each numpy array in HBM_data has dimensions
    stations x (2 pol) x (fine channels) x (192 times)
    :param data_valid: List of numpy arrays as per HBM_data, with a flag to
    indicate if the data sample is valid. Data valid applies to both
    polarisations, so the dimensions of each numpy array is
    stations x (fine channels) x (192 times)
    :param subarray_beam_table: array of uint32, contents of the firmware subarray-beam table.
    :param gen_lta_output: boolean, generates text files with the output of the long term accumulator (LTA)
    :param lta_fname: filename for the LTA visibilities
    :param tci_fd_fname: filename for the LTA time centroid and fraction-data output
    :param lta_HBM_fname: filename for the HBM contents written by the LTA. This is the
    combined contents of the previous two files, with the tci_fd data offset by 256 MBytes.
    :param lta_HBM_dbg_fname: Same as lta_HBM_fname, but file contains debug data with
    meta data replacing the correlated data.

    :returns:
    A list with 256 entries, one for each entry in the subarray_beam_table.
    Each entry in the list is a tuple with (normalised_correlation, FD, TCI)
    where :
    normalised_correlation is a numpy array with dimensions:
    (channels x time_groups x stations x stations x 2 pol x 2 pol)
    FD (fraction of data) and TCI (time centroid interval) are numpy arrays
    with dimensions: (channels x time_groups x stations x stations)
    (note there a single FD and TCI for each of the 4 possible combinations of
    polarisations)
    """
    # Define the output list.
    dout = []

    if gen_lta_output:
        lta_data_file = open(lta_fname, "w")
        tci_fd_file = open(tci_fd_fname, "w")
        lta_HBM_file = open(lta_HBM_fname, "w")
        lta_HBM_dbg_file = open(lta_HBM_dbg_fname, "w")
    lta_data_file_address = 0
    tci_fd_data_file_address = 0
    # 256 MByte offset in the HBM for the tci_fd data
    # HBM init addresses are 4-byte word addresses,
    # so 256 Mbyte = 2**28 bytes = 2**26 (4-byte words)
    tci_fd_HBM_file_address = 2**26

    # step through each entry in the subarray-beam table
    for sb_index in range(256):
        sb_entry = subarray_beam_unpack(subarray_beam_table, sb_index)

        if sb_entry["N_stations"] > 0:
            cur_hbm_data = hbm_data[sb_index]
            cur_valid = data_valid[sb_index]
            # Number of channels to produce
            n_output_channels = int(
                np.floor(sb_entry["N_fine"] / sb_entry["N_fine_integrate"])
            )
            if sb_entry["N_time_integrate"] == 64:
                time_groups = 3
            else:
                time_groups = 1

            # Array to hold the correlation. Indexed by
            # (channel, time_group, station1, station2, station1_pol, station2_pol)
            # Note : either 1 or 3 time_groups, depending on the integration time.
            correlation = np.zeros(
                (
                    n_output_channels,
                    time_groups,
                    sb_entry["N_stations"],
                    sb_entry["N_stations"],
                    2,
                    2,
                ),
                dtype=np.complex64,
            )
            # The size of normalised_correlation is adjusted to a multiple of
            # 16 stations, since we need a multiple of 16 stations to emulate
            # the firmware, which writes data out in "cells" of 16x16 stations.
            n_stations_16 = int(np.ceil(sb_entry["N_stations"] / 16) * 16)
            normalised_correlation = np.zeros(
                (
                    n_output_channels,
                    time_groups,
                    n_stations_16,
                    n_stations_16,
                    2,
                    2,
                ),
                dtype=np.complex64,
            )
            # dbg_correlation puts meta data into the data array, to make it easier
            # to debug. Since meta data is integers, an extra dimension is added so that
            # the array has the same size as the normalised_correlation array, which is complex.
            # (There is no complex integer type in numpy).
            dbg_correlation = np.zeros(
                (
                    n_output_channels,
                    time_groups,
                    n_stations_16,
                    n_stations_16,
                    2,
                    2,
                    2,
                ),
                dtype=np.uint32,
            )
            # Array to hold the number of contributing samples for each correlation product.
            valid_count = np.zeros(
                (
                    n_output_channels,
                    time_groups,
                    sb_entry["N_stations"],
                    sb_entry["N_stations"],
                ),
                dtype=np.uint32,
            )
            # Weight is sum(valid x sample_number), which is used to calculate
            # the time centroid of the integration.
            valid_weight = np.zeros(
                (
                    n_output_channels,
                    time_groups,
                    sb_entry["N_stations"],
                    sb_entry["N_stations"],
                ),
                dtype=np.uint32,
            )
            tci = np.zeros(
                (n_output_channels, time_groups, n_stations_16, n_stations_16),
                dtype=np.int32,
            )
            fd = np.zeros(
                (n_output_channels, time_groups, n_stations_16, n_stations_16),
                dtype=np.uint32,
            )
            dbg_tci = np.zeros(
                (n_output_channels, time_groups, n_stations_16, n_stations_16),
                dtype=np.int32,
            )
            dbg_fd = np.zeros(
                (n_output_channels, time_groups, n_stations_16, n_stations_16),
                dtype=np.uint32,
            )
            # Define an array with a counter in it, which is used to find the
            # weighted sum for the time centroid.
            counter_array = np.arange(sb_entry["N_time_integrate"])
            # total number of samples which can contribute to an output sample
            total_samples = (
                sb_entry["N_time_integrate"] * sb_entry["N_fine_integrate"]
            )

            for output_channel in range(n_output_channels):
                for output_time in range(time_groups):

                    # Find the first and last time sample to integrate
                    if time_groups == 1:
                        time_start = 0
                        time_end = 192
                        t_i_max = 192
                    else:
                        time_start = output_time * 64
                        time_end = (output_time + 1) * 64
                        t_i_max = 64

                    for station1 in range(sb_entry["N_stations"]):
                        # Station2 only needs to runs 0 to (station1+1), to calculate
                        # the lower half of the correlation matrix.
                        # However, the firmware calculates everything in a 16x16 block,
                        # so we do the same here to make the comparison with the firmware easier.
                        station2_range = np.minimum(
                            int(np.ceil((station1 + 1.0) / 16) * 16),
                            sb_entry["N_stations"],
                        )
                        for station2 in range(station2_range):
                            # Number of contributing samples and sample weight is the same for both polarisations
                            valid_count[
                                output_channel, output_time, station1, station2
                            ] = np.sum(
                                cur_valid[
                                    station1,
                                    (
                                        output_channel
                                        * sb_entry["N_fine_integrate"]
                                    ) : (
                                        (output_channel + 1)
                                        * sb_entry["N_fine_integrate"]
                                    ),
                                    time_start:time_end,
                                ]
                                * cur_valid[
                                    station2,
                                    (
                                        output_channel
                                        * sb_entry["N_fine_integrate"]
                                    ) : (
                                        (output_channel + 1)
                                        * sb_entry["N_fine_integrate"]
                                    ),
                                    time_start:time_end,
                                ]
                            )
                            valid_weight[
                                output_channel, output_time, station1, station2
                            ] = np.sum(
                                cur_valid[
                                    station1,
                                    (
                                        output_channel
                                        * sb_entry["N_fine_integrate"]
                                    ) : (
                                        (output_channel + 1)
                                        * sb_entry["N_fine_integrate"]
                                    ),
                                    time_start:time_end,
                                ]
                                * cur_valid[
                                    station2,
                                    (
                                        output_channel
                                        * sb_entry["N_fine_integrate"]
                                    ) : (
                                        (output_channel + 1)
                                        * sb_entry["N_fine_integrate"]
                                    ),
                                    time_start:time_end,
                                ]
                                * counter_array
                            )

                            # TCI = Time centroid interval = time centroid for
                            # each visibility, scaled to an 8 bit signed integer,
                            # 256 / t_i_max * sum(T_i)/valid_count - 128
                            # where t_i_max = max time sample index, either 192 or 64
                            # T_i = time sample indexes for each contributing sample
                            # Note sum(T_i) = valid_weight (Calculated above)
                            # valid_count = Number of contributing samples, calculated above.
                            # FD = fraction of data, as an 8 bit unsigned int
                            #    = 256 * sqrt(valid_count/total_samples),
                            # i.e. fraction of data which was used, scaled to 8 bits.
                            tci[
                                output_channel, output_time, station1, station2
                            ] = np.round(
                                (256 / t_i_max)
                                * valid_weight[
                                    output_channel,
                                    output_time,
                                    station1,
                                    station2,
                                ]
                                / valid_count[
                                    output_channel,
                                    output_time,
                                    station1,
                                    station2,
                                ]
                                - 128
                            )

                            fd[
                                output_channel, output_time, station1, station2
                            ] = np.round(
                                255
                                * np.sqrt(
                                    valid_count[
                                        output_channel,
                                        output_time,
                                        station1,
                                        station2,
                                    ]
                                    / total_samples
                                )
                            )
                            # dbg_tciand dbg_fd put meta data in the array to make debugging easier.
                            dbg_tci[
                                output_channel, output_time, station1, station2
                            ] = (station2 + 1) * 16 + (station1 + 1)
                            dbg_fd[
                                output_channel, output_time, station1, station2
                            ] = output_channel

                            for pol1 in range(2):
                                for pol2 in range(2):
                                    correlation[
                                        output_channel,
                                        output_time,
                                        station1,
                                        station2,
                                        pol1,
                                        pol2,
                                    ] = np.sum(
                                        cur_hbm_data[
                                            station1,
                                            pol1,
                                            (
                                                output_channel
                                                * sb_entry["N_fine_integrate"]
                                            ) : (
                                                (output_channel + 1)
                                                * sb_entry["N_fine_integrate"]
                                            ),
                                            time_start:time_end,
                                        ]
                                        * np.conj(
                                            cur_hbm_data[
                                                station2,
                                                pol2,
                                                (
                                                    output_channel
                                                    * sb_entry[
                                                        "N_fine_integrate"
                                                    ]
                                                ) : (
                                                    (output_channel + 1)
                                                    * sb_entry[
                                                        "N_fine_integrate"
                                                    ]
                                                ),
                                                time_start:time_end,
                                            ]
                                        )
                                    )
                                    # To normalise the visibilities, scale up
                                    # the correlation to account for missing
                                    # values.
                                    # visibilites = correlation /
                                    #          (valid samples / total samples)
                                    normalised_correlation[
                                        output_channel,
                                        output_time,
                                        station1,
                                        station2,
                                        pol1,
                                        pol2,
                                    ] = (
                                        correlation[
                                            output_channel,
                                            output_time,
                                            station1,
                                            station2,
                                            pol1,
                                            pol2,
                                        ]
                                        * total_samples
                                        / valid_count[
                                            output_channel,
                                            output_time,
                                            station1,
                                            station2,
                                        ]
                                    )
                            # debug correlation puts meta data in the array to make debugging easier.
                            dbg_correlation[
                                output_channel,
                                output_time,
                                station1,
                                station2,
                                0,
                                0,
                                0,
                            ] = (
                                station1 + 1
                            )
                            dbg_correlation[
                                output_channel,
                                output_time,
                                station1,
                                station2,
                                0,
                                0,
                                1,
                            ] = 0
                            dbg_correlation[
                                output_channel,
                                output_time,
                                station1,
                                station2,
                                0,
                                1,
                                0,
                            ] = (
                                station2 + 1
                            )
                            dbg_correlation[
                                output_channel,
                                output_time,
                                station1,
                                station2,
                                0,
                                1,
                                1,
                            ] = 0
                            dbg_correlation[
                                output_channel,
                                output_time,
                                station1,
                                station2,
                                1,
                                0,
                                0,
                            ] = output_time
                            dbg_correlation[
                                output_channel,
                                output_time,
                                station1,
                                station2,
                                1,
                                0,
                                1,
                            ] = 0
                            dbg_correlation[
                                output_channel,
                                output_time,
                                station1,
                                station2,
                                1,
                                1,
                                0,
                            ] = output_channel
                            dbg_correlation[
                                output_channel,
                                output_time,
                                station1,
                                station2,
                                1,
                                1,
                                1,
                            ] = 0
                    # Write out normalised correlation, TCI, and FD to a file
                    # for comparison with the firmware
                    if gen_lta_output:

                        # A tile is a block of 256x256 stations from the correlation matrix
                        # A cell is a block of 16x16 stations from the correlation matrix
                        # The for loops below copy the order data is produced in the firmware.
                        tile_rows = int(np.ceil(sb_entry["N_stations"] / 256))
                        tci_fd = np.zeros(512, dtype=np.uint8)
                        dbg_tci_fd = np.zeros(512, dtype=np.uint8)
                        for tile_row in range(tile_rows):
                            for tile_col in range(tile_row + 1):
                                if tile_row < (tile_rows - 1):
                                    cell_rows = 16
                                else:
                                    cell_rows = int(
                                        np.ceil(
                                            np.mod(sb_entry["N_stations"], 256)
                                            / 16
                                        )
                                    )
                                for cell_row in range(cell_rows):
                                    if tile_row == tile_col:
                                        # This tile sits on the diagonal of the
                                        # correlation matrix and so is a triangle.
                                        cell_columns = cell_row + 1
                                    else:
                                        cell_columns = 16
                                    for cell_col in range(cell_columns):
                                        # Write out cells (16x16 stations) as chunks of 8192 bytes.
                                        row_first_station = (
                                            tile_row * 256 + cell_row * 16
                                        )
                                        col_first_station = (
                                            tile_col * 256 + cell_col * 16
                                        )
                                        single_cell = normalised_correlation[
                                            output_channel,
                                            output_time,
                                            row_first_station : (
                                                row_first_station + 16
                                            ),
                                            col_first_station : (
                                                col_first_station + 16
                                            ),
                                            :,
                                            :,
                                        ]
                                        single_cell_dbg = dbg_correlation[
                                            output_channel,
                                            output_time,
                                            row_first_station : (
                                                row_first_station + 16
                                            ),
                                            col_first_station : (
                                                col_first_station + 16
                                            ),
                                            :,
                                            :,
                                            :,
                                        ]
                                        # magic conversion: tobytes uses C order in the array, so should step
                                        # through real, imaginary, pol1, pol2, col station, row station.
                                        # Also tobytes() interpreted as uint32 results in 32bit single precision
                                        # values being written out as hex.
                                        block_2048_words = np.frombuffer(
                                            single_cell.tobytes(),
                                            dtype=np.uint32,
                                        )
                                        block_2048_words_dbg = np.frombuffer(
                                            single_cell_dbg.tobytes(),
                                            dtype=np.uint32,
                                        )
                                        # text data file is format required for loading of the HBM testbench model.
                                        # Consists of 32-bit hex words, with each line containing the address,
                                        # then 128 words of data.
                                        for line512byte in range(16):
                                            lta_data_file.write(
                                                f"{lta_data_file_address:08x}"
                                            )
                                            lta_HBM_file.write(
                                                f"{lta_data_file_address:08x}"
                                            )
                                            lta_HBM_dbg_file.write(
                                                f"{lta_data_file_address:08x}"
                                            )
                                            lta_data_file_address += (
                                                512 // 4
                                            )  # 4 byte address used for HBM memory init
                                            for w in range(128):
                                                lta_data_file.write(
                                                    f" {block_2048_words[line512byte*128 + w]:08x}"
                                                )
                                                lta_HBM_file.write(
                                                    f" {block_2048_words[line512byte*128 + w]:08x}"
                                                )
                                                lta_HBM_dbg_file.write(
                                                    f" {block_2048_words_dbg[line512byte*128 + w]:08x}"
                                                )
                                            lta_data_file.write("\n")
                                            lta_HBM_file.write("\n")
                                            lta_HBM_dbg_file.write("\n")
                                        # Generate the TCI and DV data file; 512 bytes
                                        tci_cell = np.uint8(
                                            tci[
                                                output_channel,
                                                output_time,
                                                row_first_station : (
                                                    row_first_station + 16
                                                ),
                                                col_first_station : (
                                                    col_first_station + 16
                                                ),
                                            ]
                                        )
                                        fd_cell = np.uint8(
                                            fd[
                                                output_channel,
                                                output_time,
                                                row_first_station : (
                                                    row_first_station + 16
                                                ),
                                                col_first_station : (
                                                    col_first_station + 16
                                                ),
                                            ]
                                        )
                                        dbg_tci_cell = np.uint8(
                                            dbg_tci[
                                                output_channel,
                                                output_time,
                                                row_first_station : (
                                                    row_first_station + 16
                                                ),
                                                col_first_station : (
                                                    col_first_station + 16
                                                ),
                                            ]
                                        )
                                        dbg_fd_cell = np.uint8(
                                            dbg_fd[
                                                output_channel,
                                                output_time,
                                                row_first_station : (
                                                    row_first_station + 16
                                                ),
                                                col_first_station : (
                                                    col_first_station + 16
                                                ),
                                            ]
                                        )
                                        tci_fd[
                                            0:512:2
                                        ] = tci_cell.flatten().copy()
                                        tci_fd[
                                            1:512:2
                                        ] = fd_cell.flatten().copy()
                                        dbg_tci_fd[
                                            0:512:2
                                        ] = dbg_tci_cell.flatten().copy()
                                        dbg_tci_fd[
                                            1:512:2
                                        ] = dbg_fd_cell.flatten().copy()

                                        tci_fd_words = np.frombuffer(
                                            tci_fd.tobytes(), dtype=np.uint32
                                        )
                                        dbg_tci_fd_words = np.frombuffer(
                                            dbg_tci_fd.tobytes(),
                                            dtype=np.uint32,
                                        )
                                        tci_fd_file.write(
                                            f"{tci_fd_data_file_address:08x}"
                                        )
                                        lta_HBM_file.write(
                                            f"{tci_fd_HBM_file_address:08x}"
                                        )
                                        lta_HBM_dbg_file.write(
                                            f"{tci_fd_HBM_file_address:08x}"
                                        )
                                        tci_fd_data_file_address += (
                                            512 // 4
                                        )  # Address is in units of 4 bytes.
                                        tci_fd_HBM_file_address += (
                                            512 // 4
                                        )  # Address is in units of 4 bytes.
                                        for w in range(128):
                                            tci_fd_file.write(
                                                f" {tci_fd_words[w]:08x}"
                                            )
                                            lta_HBM_file.write(
                                                f" {tci_fd_words[w]:08x}"
                                            )
                                            lta_HBM_dbg_file.write(
                                                f" {dbg_tci_fd_words[w]:08x}"
                                            )
                                        tci_fd_file.write("\n")
                                        lta_HBM_file.write("\n")
                                        lta_HBM_dbg_file.write("\n")
            dout.append((normalised_correlation, fd, tci))
        else:
            # Just put in a dummy value, so that dout can be indexed in the
            # same way as subarray_beam_table
            dout.append(0)

    return dout


def write_pcap_file(file_name, pkt):
    wrpcap(file_name, pkt, append=True)


def get_bin(x: int, n_bits: int) -> str:
    """
    Convert a number to a binary string
    """
    return format(x, "b").zfill(n_bits)


def convert_little_to_big(int_to_convert, number_of_bytes):
    int_to_convert_bytes = int_to_convert.to_bytes(
        number_of_bytes, byteorder="little"
    )
    byte_array = bytearray(int_to_convert_bytes)
    return int.from_bytes(byte_array, byteorder="big")


def generate_initialisation_template(
    frequency_channel: int,
    nb_baseline: int,
    scan_id: int,
    subarray: int,
    beam: int,
    coarse_start: int,
    fine_start: int,
    n_fine_integrate: int,
    hardware_id: int,
    subarray_id: int,
    integration_period: float,
    freq_bandwidth: float,
    resolution: int,
    zoom_id: int,
    firmware_id: int,
) -> bytes:
    """
    Function used to generate an initialisation SPEAD content

    :param frequency_channel: this is the visibility channel
    :param nb_baseline: total number of baselines,
    :param scan_id: the current scan ID,
    :param subarray: The subarray ID,
    :param beam: the station beam ID,
    :param coarse_start: representing the beginning of the coarse channel for this scan,
    :param fine_start: representing the beginning of the fine channel for this scan,
    :param n_fine_integrate: the number of fine (i.e. 226 Hz) channels that are integrated per output channel,
    :param hardware_id: the alveo ID,
    :param subarray_id: the subarray ID,
    :param integration_period: the integration period (0.849s for basic correlation),
    :param freq_bandwidth: the bandwitdh of a coarse channel,
    :param resolution: the resolution (1 for normal, 2 for half),
    :param zoom_id: the zoom_id,
    :param firmware_id: the firmware version,
    """
    correlation_type = (
        "{'descr': [('VIS','<c8', (4,)), ('TCI','|i1'), ('FD', '|u1')], 'fortran_order':False, 'shape':("
        + f"{nb_baseline}"
        + ",)}"
    )
    correlation_description = f"Corre{correlation_type}"

    u4_description = "{'descr': '<u4', 'fortran_order':False, 'shape':()}"
    f4_description = "{'descr': '<f4', 'fortran_order':False, 'shape':()}"
    u1_description = "{'descr': '<u1', 'fortran_order':False, 'shape':()}"
    u2_description = "{'descr': '<u2', 'fortran_order':False, 'shape':()}"
    u8_description = "{'descr': '<u8', 'fortran_order':False, 'shape':()}"
    s1_description = (  # string, one byte
        "{'descr': '|S1', 'fortran_order':False, 'shape':()}"
    )
    scan_id_to_convert_bytes = scan_id.to_bytes(8, byteorder="little")
    byte_array_scan_id = bytearray(scan_id_to_convert_bytes)
    packet = (
        byte_array_scan_id
        / SpeadDescriptor(
            Identifier=0x6013,  # Visibility SPS Epoch
            HeapSize=5 + len(u4_description),
            PayloadSize=5 + len(u4_description),
        )
        / f"Epoch{u4_description}"
        / SpeadDescriptor(
            Identifier=0x6014,  # Visibility SPS Epoch Offset
            HeapSize=5 + len(u8_description),
            PayloadSize=5 + len(u8_description),
        )
        / f"tOffs{u8_description}"
        / SpeadDescriptor(
            Identifier=0x6002,  # Channel ID
            HeapSize=5 + len(u4_description),
            PayloadSize=5 + len(u4_description),
        )
        / f"Chann{u4_description}"
        / SpeadDescriptor(
            Identifier=0x6005,  # No. of baselines
            HeapSize=5 + len(u4_description),
            PayloadSize=5 + len(u4_description),
        )
        / f"Basel{u4_description}"
        / SpeadDescriptor(
            Identifier=0x6008,  # Scan ID
            HeapSize=5 + len(u8_description),
            PayloadSize=5 + len(u8_description),
        )
        / f"ScaID{u8_description}"
        / SpeadDescriptor(
            Identifier=0x6015,  # CBF Source ID (L/M)
            HeapSize=5 + len(s1_description),
            PayloadSize=5 + len(s1_description),
        )
        / f"SrcID{s1_description}"
        / SpeadDescriptor(
            Identifier=0x6009,  # CBF Hardware ID
            HeapSize=5 + len(u4_description),
            PayloadSize=5 + len(u4_description),
        )
        / f"Hardw{u4_description}"
        / SpeadDescriptor(
            Identifier=0x600B,  # Station Beam ID
            HeapSize=5 + len(u2_description),
            PayloadSize=5 + len(u2_description),
        )
        / f"BeaID{u2_description}"
        / SpeadDescriptor(
            Identifier=0x600C,  # Subarray ID
            HeapSize=5 + len(u2_description),
            PayloadSize=5 + len(u2_description),
        )
        / f"Subar{u2_description}"
        / SpeadDescriptor(
            Identifier=0x600D,  # Integration Period
            HeapSize=5 + len(f4_description),
            PayloadSize=5 + len(f4_description),
        )
        / f"Integ{f4_description}"
        / SpeadDescriptor(
            Identifier=0x600E,  # Freq. Resolution
            HeapSize=5 + len(f4_description),
            PayloadSize=5 + len(f4_description),
        )
        / f"Frequ{f4_description}"
        / SpeadDescriptor(
            Identifier=0x600F,  # Output Resolution
            HeapSize=5 + len(u1_description),
            PayloadSize=5 + len(u1_description),
        )
        / f"Resol{u1_description}"
        / SpeadDescriptor(
            Identifier=0x6010,  # Channel Freq.
            HeapSize=5 + len(u4_description),
            PayloadSize=5 + len(u4_description),
        )
        / f"FreHz{u4_description}"
        / SpeadDescriptor(
            Identifier=0x6011,  # Zoom Window ID
            HeapSize=5 + len(u1_description),
            PayloadSize=5 + len(u1_description),
        )
        / f"ZoomI{u1_description}"
        / SpeadDescriptor(
            Identifier=0x6012,  # Firmware Version
            HeapSize=5 + len(u4_description),
            PayloadSize=5 + len(u4_description),
        )
        / f"Firmw{u4_description}"
        / SpeadDescriptor(
            Identifier=0x600A,  # baseline data (?)
            HeapSize=len(correlation_description),
            PayloadSize=len(correlation_description),
        )
        / correlation_description
    )

    bytes_val_sub_beam_channel = (
        get_bin(subarray, 8)
        + get_bin(beam, 7)
        + get_bin(frequency_channel, 17)
    )
    fine_ch_bw = 781250 * (32 / 27) / 4096  # width of a fine channel, Hz
    frequency_visibility_hz = (
        coarse_start * 781250
        + (fine_start - 3456 / 2) * fine_ch_bw
        + (frequency_channel + 0.5) * fine_ch_bw * n_fine_integrate
        - fine_ch_bw / 2
    )
    packet_to_save = (
        SpeadInitialisation(
            SubArray_Beam_Frequency=int(bytes_val_sub_beam_channel, 2),
            HeapSize=len(packet),
            PayloadSize=len(packet),
            Channel=convert_little_to_big(frequency_channel, 4),
            integrationID=0,
            NumberOfItems=35,
            OffsetSize=0,
            TimeSPS=0,
            Baseline=convert_little_to_big(nb_baseline, 4),
            Hardware=convert_little_to_big(hardware_id, 4),  # Alveo ID fake
            Beam=convert_little_to_big(
                beam, 2
            ),  # assuming only 1 beam here need to check if we can find it in the model
            Subarray=convert_little_to_big(
                subarray_id, 2
            ),  # again need to check in the model
            Integration=int.from_bytes(
                np.float32(integration_period).tobytes(), byteorder="big"
            ),  # in seconds
            Frequency=int.from_bytes(
                np.float32(freq_bandwidth).tobytes(), byteorder="big"
            ),  # in hertz
            Resolution=resolution,  # 1 for simple, 2 for half
            FrequencyHz=convert_little_to_big(int(frequency_visibility_hz), 4),
            ZoomID=zoom_id,
            Firmware=firmware_id,
        )
        / packet
    )

    return bytes(packet_to_save)


def main():
    """correlator_model main function"""
    args = command_line_args()

    register_file = open(f"{args.test_case}/tb/HWData1.txt", "rt")
    lfaa_headers = open(f"{args.test_case}/LFAAHeaders_fpga1.raw", "rb")
    lfaa_data = open(f"{args.test_case}/LFAAData_fpga1.raw", "rb")
    filterbank_fir_taps = open(f"{args.filterbank_taps}", "rt")
    # Generated text file with initialisation data for the HBM for the
    # simulation at the output of the second corner turn.
    ct2_fname = f"{args.test_case}/ct2_init.txt"
    # CT2 HBM data, downloaded from the HBM, either from sim or Alveo
    ct2_check_fname = ""  # f"{args.test_case}/ct2_hbm_dump.txt"
    # Generated text file with the HBM data at the output of the long term
    # accumulator.
    lta_vis_fname = f"{args.test_case}/LTA_vis_check.txt"
    tci_fd_fname = f"{args.test_case}/LTA_TCI_FD_check.txt"
    lta_HBM_fname = f"{args.test_case}/LTA_HBM_check.txt"
    lta_HBM_dbg_fname = f"{args.test_case}/LTA_HBM_dbg_check.txt"
    sps_tb_data_file = open(f"{args.test_case}/sps_axi_tb_input.txt", "wt")
    tb_reg_filename = f"{args.test_case}/tb_registers.txt"
    ccfg_file = open(f"{args.ccfg}", "rt")

    # Load the register settings
    registers = parse_registers(register_file)
    # Rewrite the register file with the register names converted to addresses
    register_file.seek(0)
    write_tb_regfile(register_file, ccfg_file, tb_reg_filename)

    # Get the SPS RAW files. Returns a list of ethernet packets.
    eth_packets = load_raw(lfaa_headers, lfaa_data)

    # Decode the Ethernet packets into samples.
    # samples is a numpy array with dimensions
    # (virtual_channels) * (2 polarisations) * (time samples)
    samples = decode.decode_ethernet(
        eth_packets, registers["lfaadecode100g.statctrl.vctable"]
    )

    # Write a text file with the SPS input packets for the testbench.
    # 6 station case : use 768 fast packets (6*128)
    decode.write_tb_axi(eth_packets, sps_tb_data_file, 768, 3200, 23.5)
    # decode.write_tb_axi(eth_packets, sps_tb_data_file, 256, 1600, 12)

    # send samples through the filterbank
    # Result :
    # fine_data : Array with dimensions (virtual channel) x (pol) x
    #     (3456 fine channels) x (time samples)
    # floating point data type, but in the range +/-127,
    # with RFI or saturated samples = -128
    #
    # fine_valid : as per fine_data, but with no polarisation dimension.
    # If either polarisation is clipped, then the sample is bad.
    (fine_data, fine_valid) = run_filterbank(
        registers["corr_ct1.config.table_0"],
        samples,
        filterbank_fir_taps,
        args.plot,
    )

    # Step through each 849ms piece of data,
    #  - Generate the second corner turn HBM contents
    #  - write out the second corner turn HBM contents
    #  - Run the correlator for the frame
    correlator_frames = int(np.floor(fine_data.shape[3] / 192))
    correlated = []
    for correlator_frame in range(correlator_frames):
        file_write = correlator_frame == 0
        # Note fine_data already has saturated or RFI samples set to -128
        (ct2_hbm_data, ct2_data_valid) = get_corr_hbm(
            fine_data[
                :,
                :,
                :,
                (correlator_frame * 192) : ((correlator_frame + 1) * 192),
            ],
            fine_valid[
                :, :, (correlator_frame * 192) : ((correlator_frame + 1) * 192)
            ],
            registers["corr_ct2.statctrl.vc_demap"],
            registers["corr_ct2.statctrl.subarray_beam"],
            do_file_write=file_write,
            fname=ct2_fname,
            fname_check=ct2_check_fname,
        )
        # Run the correlator
        # The output is a list with one entry for each entry in the
        # subarray_beam table, where each entry is a tuple with 3 numpy arrays:
        # (normalised_correlation, FD, TCI)
        correlated.append(
            run_correlation(
                ct2_hbm_data,
                ct2_data_valid,
                registers["corr_ct2.statctrl.subarray_beam"],
                gen_lta_output=file_write,
                lta_fname=lta_vis_fname,
                tci_fd_fname=tci_fd_fname,
                lta_HBM_fname=lta_HBM_fname,
                lta_HBM_dbg_fname=lta_HBM_dbg_fname,
            )
        )

    clist = "rgbcmyk"
    test_case_name = args.test_case.split("/")[-1]
    if args.plot:
        # Plot something...
        print("Plotting visibilities")
        cplot = np.zeros((144, 6, correlator_frames), dtype=np.complex64)
        for correlator_frame in range(correlator_frames):
            # Extract the station1 vs first 6 stations for all the time samples
            cplot[0:144, 0:6, correlator_frame] = np.squeeze(
                correlated[correlator_frame][0][0][0:144, 0, 0:6, 0, 0, 0]
            )

        plt.figure(3)
        plt.clf()
        for frame in range(6):
            plt.subplot(6, 1, frame + 1)
            for baseline in range(6):
                plt.plot(
                    (180 / 3.14159265) * np.angle(cplot[:, baseline, frame]),
                    clist[baseline] + ".-",
                    label=f"baseline {baseline}",
                )
            plt.xlabel("frequency channel")
            plt.ylabel("phase (degrees)")
            plt.legend()
            plt.grid()
            plt.title(f"{test_case_name}, frame {frame}")

        plt.figure(4)
        plt.clf()
        baseline = 5
        for frame in range(7):
            plt.plot(
                (180 / 3.14159265) * np.angle(cplot[:, baseline - 1, frame]),
                clist[frame] + ".-",
                label=f"frame {frame}",
            )
        plt.xlabel("frequency channel")
        plt.ylabel("phase (degrees)")
        plt.grid()
        plt.legend()
        plt.title(f"{test_case_name}, baseline {baseline}")

    # Initialisation SPEAD packet
    for sb_index in range(256):
        SB_entry = subarray_beam_unpack(
            registers["corr_ct2.statctrl.subarray_beam"], sb_index
        )
        if SB_entry["N_stations"] > 0:
            for frequency_channel in range(
                SB_entry["N_fine"] // SB_entry["N_fine_integrate"]
            ):
                nd_baseline = int(
                    (SB_entry["N_stations"] * (SB_entry["N_stations"] + 1)) / 2
                )

                scan_id = 4294967296  # not present yet in the model
                port = 3457 + frequency_channel

                subarray = 1
                beam = 1
                packet_content = generate_initialisation_template(
                    frequency_channel=frequency_channel,
                    nb_baseline=nd_baseline,
                    scan_id=scan_id,
                    subarray=subarray,
                    beam=beam,
                    coarse_start=SB_entry["coarse_start"],
                    fine_start=SB_entry["fine_start"],
                    n_fine_integrate=SB_entry["N_fine_integrate"],
                    hardware_id=1234,
                    subarray_id=subarray,
                    integration_period=0.849,
                    freq_bandwidth=5425.3,
                    resolution=1,
                    zoom_id=1,
                    firmware_id=int(0x00010203),
                )
                packet_to_save = (
                    Ether()
                    / IP(dst="192.168.1.101")
                    / UDP(sport=port - 1, dport=port)
                    / packet_content
                )

                if args.write_to_file is not None:
                    write_pcap_file(args.write_to_file, packet_to_save)
                if args.packet:
                    sendp(
                        packet_to_save,
                        iface=args.interface_to_send,
                    )
                    if args.write_to_file is not None:
                        write_pcap_file(args.write_to_file, packet_to_save)
                    if args.packet:
                        sendp(
                            packet_to_save,
                            iface=args.interface_to_send,
                        )

    # Get number of subarray, number of stations etc from the subarray beam table (use unpack function)
    for correlator_frame in range(correlator_frames):
        for sb_index in range(256):
            SB_entry = subarray_beam_unpack(
                registers["corr_ct2.statctrl.subarray_beam"], sb_index
            )
            if SB_entry["N_stations"] > 0:
                for frequency_channel in range(
                    SB_entry["N_fine"] // SB_entry["N_fine_integrate"]
                ):
                    # build data that goes into a stream of packets with one frequency channel
                    # packet_contents may be a single packets worth or up to several thousand packets.
                    # Total of 34 bytes per station pair.
                    packet_contents = bytearray(
                        34
                        * SB_entry["N_stations"]
                        * (SB_entry["N_stations"] + 1)
                        // 2
                    )
                    cur_sample = 0
                    port = 3457 + frequency_channel
                    for station1 in range(SB_entry["N_stations"]):
                        for station2 in range(station1 + 1):
                            # 4*8 = 32 bytes of visibilities
                            packet_contents[
                                (cur_sample * 34) : (cur_sample * 34 + 32)
                            ] = correlated[correlator_frame][sb_index][0][
                                frequency_channel, 0, station1, station2, :, :
                            ].tobytes()
                            # add 1 byte TCI 32 bit signed integer (need casting properly)
                            packet_contents[cur_sample * 34 + 32] = np.uint8(
                                correlated[correlator_frame][sb_index][2][
                                    frequency_channel, 0, station1, station2
                                ]
                            )
                            # add 1 byte FD (from 32 bits unsigned integer)
                            packet_contents[cur_sample * 34 + 33] = np.uint8(
                                correlated[correlator_frame][sb_index][1][
                                    frequency_channel, 0, station1, station2
                                ]
                            )

                            cur_sample += 1

                    subarray = 1  # not sure if it is somewhere else
                    beam = 1  # not sure if it is somewhere else
                    bytes_val_sub_beam_channel = (
                        get_bin(subarray, 8)
                        + get_bin(beam, 7)
                        + get_bin(frequency_channel, 17)
                    )
                    size = len(packet_contents)
                    scan_id = 4294967296  # not present yet in the model
                    TimeSPSOffset = (
                        correlator_frame + 1
                    ) * 849  # time in nanosecond

                    TimeSPSOffset_to_convert_bytes = TimeSPSOffset.to_bytes(
                        8, byteorder="little"
                    )
                    byte_array = bytearray(TimeSPSOffset_to_convert_bytes)

                    spead_packet = (
                        SpeadSDP(
                            SubArray_Beam_Frequency=int(
                                bytes_val_sub_beam_channel, 2
                            ),
                            integrationID=correlator_frame + 1,
                            HeapSize=size + 8,
                            PayloadSize=size + 8,
                        )
                        / byte_array
                        / packet_contents
                    )

                    packet_to_save = (
                        Ether()
                        / IP()
                        / UDP(sport=port - 1, dport=port)
                        / spead_packet
                    )
                    if args.write_to_file is not None:
                        write_pcap_file(args.write_to_file, packet_to_save)
                    if args.packet:
                        sendp(
                            packet_to_save,
                            iface=args.interface_to_send,
                        )

                    # Chop packet_contents into appropriately sized chunks of data to be transported via SPEAD
    # Closing all SPEAD streams
    for sb_index in range(256):
        SB_entry = subarray_beam_unpack(
            registers["corr_ct2.statctrl.subarray_beam"], sb_index
        )
        if SB_entry["N_stations"] > 0:
            for frequency_channel in range(
                SB_entry["N_fine"] // SB_entry["N_fine_integrate"]
            ):
                port = 3457 + frequency_channel
                packet_to_save = (
                    Ether()
                    / IP(dst="192.168.1.101")
                    / UDP(sport=port - 1, dport=port)
                    / SpeadEnd()
                )
                if args.write_to_file is not None:
                    write_pcap_file(args.write_to_file, packet_to_save)
                if args.packet:
                    sendp(
                        packet_to_save,
                        iface=args.interface_to_send,
                    )

    if args.plot:
        plt.figure(2)
        plt.clf()
        plt.subplot(2, 1, 1)

        for baseline in range(6):
            plt.plot(np.abs(cplot[23, baseline, :]), clist[baseline] + ".-")
        plt.ylim(0, 1.5 * np.max(np.abs(cplot[23, baseline, :])))
        plt.grid()
        plt.title("Absolute value, 6 baselines, channel 23")
        plt.xlabel("time sample (0.849 seconds/sample)")

        plt.subplot(2, 1, 2)
        for baseline in range(6):
            plt.plot(np.angle(cplot[23, baseline, :]), clist[baseline] + ".-")
        plt.title("Phase, 6 baselines, channel 23")
        plt.grid()
        plt.xlabel("time sample (0.849 seconds/sample)")
        plt.ylabel("phase (radians)")

        # plt.subplot(3, 1, 3)
        # for baseline in range(6):
        #    plt.plot(np.angle(cplot[72, baseline, :]), clist[baseline] + '.-')
        # plt.title("Phase, 6 baselines, channel 72")
        # plt.xlabel('time sample (0.849 seconds/sample)')
        # plt.ylabel('phase (radians)')

        # plt.figure(3)
        # plt.clf()
        # for baseline in range(6):
        #    plt.plot(np.angle(cplot[:,baseline,0]),clist[baseline] + '.-')
        # plt.title('phase across channels for 6 baselines')
        # plt.xlabel('channel')
        plt.show()

    # Generate output packets


if __name__ == "__main__":
    main()
